<?php
if(is_multisite()){
	$response_key = get_blog_option($blog_id, 'spam_master_status');
	$spam_master_honeypot_timetrap = get_blog_option($blog_id, 'spam_master_honeypot_timetrap');
	$spam_master_honeypot_timetrap_speed = get_blog_option($blog_id, 'spam_master_honeypot_timetrap_speed');
}
else{
	$response_key = get_option('spam_master_status');
	$spam_master_honeypot_timetrap = get_option('spam_master_honeypot_timetrap');
	$spam_master_honeypot_timetrap_speed = get_option('spam_master_honeypot_timetrap_speed');
}
if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){

	if ($spam_master_honeypot_timetrap == 'true'){
		//MULTISITE HOOKS
		if(is_multisite()){
			add_action('signup_extra_fields', 'spam_master_honeypot_register_field' );
			add_action('wpmu_validate_user_signup', 'spam_master_honeypot_register_errors_multi', 99);
			add_filter('wpcf7_form_elements', 'spam_master_add_honeypot_to_form', 10, 1 );
			add_filter('wpcf7_spam', 'spam_master_contact_form_7_hoenypot');
		}
		//SINGLE SITE HOOKS
		else{
			add_action('register_form', 'spam_master_honeypot_register_field' );
			add_action('login_form', 'spam_master_honeypot_register_field');
			add_action('comment_form_after_fields', 'spam_master_honeypot_register_field', 1);
			add_filter('registration_errors', 'spam_master_honeypot_register_single_errors', 10, 3 );
			add_filter('login_errors', 'spam_master_honeypot_login_single_errors', 10, 3 );
			add_filter('preprocess_comment', 'spam_master_verify_honey_comment_data', 10, 3 );
			add_filter('wpcf7_form_elements', 'spam_master_add_honeypot_to_form', 10, 1 );
			add_filter('wpcf7_spam', 'spam_master_contact_form_7_hoenypot');
			}

		//INSERT FIELD
		function spam_master_honeypot_register_field(){
			global $wpdb, $blog_id;
			?>
			<p class="spam-master-hidden">
			<label for="mothers_name" class="spam-master-hidden"><?php _e( 'Mother Name', 'spam_master' ); ?><br>
			<input type="hidden" name="mothers_name" id="mothers_name" placeholder="Mother Name" class="input" value="" size="25" autocomplete="off" />
			</label>
			</p>
			<p class="spam-master-hidden">
			<label for="mothers_last_name" class="spam-master-hidden"><?php _e( 'Mother Last Name', 'spam_master' ); ?><br>
			<input type="hidden" name="mothers_last_name" id="mothers_last_name" placeholder="Mother Last Name" class="input" value=""  size="25" autocomplete="off" />
			</label>
			</p>
			<?php
		//END FIELD
		}

		//START REGISTRATION ERRORS VALIDATION MULTI SITE
		function spam_master_honeypot_register_errors_multi($result){
			global $wpdb, $blog_id;
			
			//Remote Ip
			$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
			//Add Tables
			$table_threats = $wpdb->prefix."spam_master_threats";
			$table_keys = $wpdb->prefix."spam_master_keys";
			
			//First check Alert and Flooding
			$spam_master_alert_level = get_blog_option($blog_id, 'spam_master_alert_level');
			if ($spam_master_alert_level == 'ALERT_3'){
				$spam_master_last_honey =  $wpdb->get_var("SELECT time FROM $table_keys WHERE spamkey = 'Honeypot' ORDER BY time DESC LIMIT 1");
				$flood_date_plus_2 = date('Y-m-d H:i:s', strtotime($spam_master_last_honey . '+ 3 minute'));
				$flood_date = current_time('mysql');
				if($flood_date_plus_2 >= $flood_date){

					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Alert 2/3 warning, honeypot registration flooding detected from Ip: ' . $blog_threat_ip ));

					$result['errors']->add('error', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
					echo '<p class="error"><strong>SPAM MASTER</strong>: Blocked IP, Domain, Email</p>';
				}
			}

			//Log System
			$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Firewall', 'spamvalue' => 'Honeypot Registration Spam Check Triggered. Incoming: '.$blog_threat_ip ));

			//Check Spam Buffer
			$is_buffer_threat = $wpdb->get_results(
								$wpdb->prepare( 
												"SELECT threat 
												FROM $table_threats
												WHERE threat = %s", 
												$blog_threat_ip
								));
			if(!empty($is_buffer_threat)){
				//insert transient
				$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in registration by spam buffer, Ip: ' . $blog_threat_ip ));
				$result['errors']->add('error', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
				echo '<p class="error"><strong>SPAM MASTER</strong>: Blocked IP, Domain, Email</p>';
				$blog_prefix = $wpdb->get_blog_prefix($blog_id);
				$count = $wpdb->query("UPDATE {$blog_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");
			}
			else {
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}

					//Report only, create data to be posted
					$blog_license_key = get_blog_option($blog_id, 'spam_license_key');
					$blog_threat_type = 'honeypot';
					$blog_web_address = get_site_url();
					$address_unclean = $blog_web_address;
					$address = preg_replace('#^https?://#', '', $address_unclean);
					@$blog_server_ip = $_SERVER['SERVER_ADDR'];
					//if empty ip
					if(empty($blog_server_ip) || $blog_server_ip == '0'){
						@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $blog_threat_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => 'honey@'.date('YmdHis').'.wp',
														'blog_threat_content' => 'Honeypot Registration Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5faG9uZXkucGhw';
					$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																								'method' => 'POST',
																								'timeout' => 45,
																								'body' => $spam_master_learning_post
																						));
					//Insert in buffer
					$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $blog_threat_ip ));
					//Log System
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in registration fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name . ', Ip: ' . $blog_threat_ip ));

					$blog_prefix = $wpdb->get_blog_prefix($blog_id);
					$count = $wpdb->query("UPDATE {$blog_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");
					
					$result['errors']->add('error', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
					echo '<p class="error"><strong>SPAM MASTER</strong>: Blocked IP, Domain, Email</p>';
				}
				else{
					//Log System
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Spam Master: honeypot registration Ok IP: ' . $blog_threat_ip ));
				}
			}
		// End Honey multi validation.
		}
		

		//START REGISTRATION ERRORS VALIDATION SINGLE SITE
		function spam_master_honeypot_register_single_errors($errors, $sanitized_user_login, $user_email){
			global $wpdb, $blog_id;

			//Remote Ip
			$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
			//Add Tables
			$table_threats = $wpdb->prefix."spam_master_threats";
			$table_keys = $wpdb->prefix."spam_master_keys";

			//First check Alert and Flooding
			$spam_master_alert_level = get_option('spam_master_alert_level');
			if ($spam_master_alert_level == 'ALERT_3'){
				$spam_master_last_honey =  $wpdb->get_var("SELECT time FROM $table_keys WHERE spamkey = 'Honeypot' ORDER BY time DESC LIMIT 1");
				$flood_date_plus_2 = date('Y-m-d H:i:s', strtotime($spam_master_last_honey . '+ 3 minute'));
				$flood_date = current_time('mysql');
				if($flood_date_plus_2 >= $flood_date){

					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Alert 2/3 warning, honeypot registration flooding detected from Ip: ' . $blog_threat_ip ));

					$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
					return $errors;
				}
			}

			//Log System
			$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Firewall', 'spamvalue' => 'Honeypot Registration Spam Check Triggered. Incoming: '.$blog_threat_ip ));

			//Check Spam Buffer
			$is_buffer_threat = $wpdb->get_results(
									$wpdb->prepare( 
													"SELECT threat 
													FROM $table_threats
													WHERE threat = %s", 
													$blog_threat_ip
									));
			if(!empty($is_buffer_threat)){
				//insert transient
				$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in registration by spam buffer, Ip: ' . $blog_threat_ip ));
				$blog_prefix = $wpdb->get_blog_prefix($blog_id);
				$count = $wpdb->query("UPDATE {$blog_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");
				$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
				return $errors;
			}
			else {
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}

					//Report only, create data to be posted
					$blog_license_key = get_option('spam_license_key');
					$blog_threat_type = 'honeypot';
					$blog_web_address = get_site_url();
					$address_unclean = $blog_web_address;
					$address = preg_replace('#^https?://#', '', $address_unclean);
					@$blog_server_ip = $_SERVER['SERVER_ADDR'];
					//if empty ip
					if(empty($blog_server_ip) || $blog_server_ip == '0'){
						@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $blog_threat_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => 'honey@'.date('YmdHis').'.wp',
														'blog_threat_content' => 'Honeypot Registration Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5faG9uZXkucGhw';
					$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																								'method' => 'POST',
																								'timeout' => 45,
																								'body' => $spam_master_learning_post
																						));
					//Log System
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in registration fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name . ', Ip: ' . $blog_threat_ip ));
					//Insert in buffer
					$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $blog_threat_ip ));

					$table_prefix = $wpdb->base_prefix;
					$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");

					$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
					return $errors;
				}
			}
		return $errors;
		// End Honey single validation.
		}

		//START LOGIN ERRORS VALIDATION SINGLE SITE
		function spam_master_honeypot_login_single_errors($error){
		global $wpdb, $blog_id, $errors;
			$err_codes = $errors->get_error_codes();
			//Remote Ip
			$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
			//Add Tables
			$table_threats = $wpdb->prefix."spam_master_threats";
			$table_keys = $wpdb->prefix."spam_master_keys";

			//First check Alert and Flooding
			$spam_master_alert_level = get_option('spam_master_alert_level');
			if ($spam_master_alert_level == 'ALERT_3'){
				$spam_master_last_honey =  $wpdb->get_var("SELECT time FROM $table_keys WHERE spamkey = 'Honeypot' ORDER BY time DESC LIMIT 1");
				$flood_date_plus_2 = date('Y-m-d H:i:s', strtotime($spam_master_last_honey . '+ 3 minute'));
				$flood_date = current_time('mysql');
				if($flood_date_plus_2 >= $flood_date){

					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Alert 2/3 warning, honeypot login  flooding detected from Ip: ' . $blog_threat_ip ));

					$error = '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email';
				}
			}

			//Log System
			$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Firewall', 'spamvalue' => 'Honeypot Login Spam Check Triggered. Incoming: '.$blog_threat_ip ));

			//Check Spam Buffer
			$is_buffer_threat = $wpdb->get_results(
									$wpdb->prepare( 
													"SELECT threat 
													FROM $table_threats
													WHERE threat = %s", 
													$blog_threat_ip
									));
			if(!empty($is_buffer_threat)){
				//insert transient
				$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in login by spam buffer, Ip: ' . $blog_threat_ip ));
				$blog_prefix = $wpdb->get_blog_prefix($blog_id);
				$count = $wpdb->query("UPDATE {$blog_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");
				$error = '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email';
			}
			else {
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}

					//Report only, create data to be posted
					$blog_license_key = get_option('spam_license_key');
					$blog_threat_type = 'honeypot';
					$blog_web_address = get_site_url();
					$address_unclean = $blog_web_address;
					$address = preg_replace('#^https?://#', '', $address_unclean);
					@$blog_server_ip = $_SERVER['SERVER_ADDR'];
					//if empty ip
					if(empty($blog_server_ip) || $blog_server_ip == '0'){
						@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $blog_threat_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => 'honey@'.date('YmdHis').'.wp',
														'blog_threat_content' => 'Honeypot Login Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5faG9uZXkucGhw';
					$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																								'method' => 'POST',
																								'timeout' => 45,
																								'body' => $spam_master_learning_post
																						));
					//Log System
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in login fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name . ', Ip: ' . $blog_threat_ip ));
					//Insert in buffer
					$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $blog_threat_ip ));

					$table_prefix = $wpdb->base_prefix;
					$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");

					$error = '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email';

				}
			}
		return $error;
		// End Honey single validation.
		}

		//COMMENT VERIFICATION
		function spam_master_verify_honey_comment_data($commentdata){
		global $wpdb, $blog_id;

			global $wpdb, $blog_id;

			//Remote Ip
			$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
			//Add Tables
			$table_threats = $wpdb->prefix."spam_master_threats";
			$table_keys = $wpdb->prefix."spam_master_keys";

			//First check Alert and Flooding
			$spam_master_alert_level = get_option('spam_master_alert_level');
			if ($spam_master_alert_level == 'ALERT_3'){
				$spam_master_last_honey =  $wpdb->get_var("SELECT time FROM $table_keys WHERE spamkey = 'Honeypot' ORDER BY time DESC LIMIT 1");
				$flood_date_plus_2 = date('Y-m-d H:i:s', strtotime($spam_master_last_honey . '+ 3 minute'));
				$flood_date = current_time('mysql');
				if($flood_date_plus_2 >= $flood_date){

					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Alert 2/3 warning, honeypot comment flooding detected from Ip: ' . $blog_threat_ip ));

					return wp_die( __( '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master' ) );
				}
			}

			//Log System
			$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Firewall', 'spamvalue' => 'Honeypot Comment Spam Check Triggered. Incoming: '.$blog_threat_ip ));

			//Check Spam Buffer
			$is_buffer_threat = $wpdb->get_results(
									$wpdb->prepare( 
													"SELECT threat 
													FROM $table_threats
													WHERE threat = %s", 
													$blog_threat_ip
									));
			if(!empty($is_buffer_threat)){
				//insert transient
				$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in comment by spam buffer, Ip: ' . $blog_threat_ip ));
				$blog_prefix = $wpdb->get_blog_prefix($blog_id);
				$count = $wpdb->query("UPDATE {$blog_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");
				return wp_die( __( '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master' ) );
			}
			else {
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}

					//Report only, create data to be posted
					$blog_license_key = get_option('spam_license_key');
					$blog_threat_type = 'honeypot';
					$blog_web_address = get_site_url();
					$address_unclean = $blog_web_address;
					$address = preg_replace('#^https?://#', '', $address_unclean);
					@$blog_server_ip = $_SERVER['SERVER_ADDR'];
					//if empty ip
					if(empty($blog_server_ip) || $blog_server_ip == '0'){
						@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $blog_threat_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => 'honey@'.date('YmdHis').'.wp',
														'blog_threat_content' => 'Honeypot Comment Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5faG9uZXkucGhw';
					$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																								'method' => 'POST',
																								'timeout' => 45,
																								'body' => $spam_master_learning_post
																						));
					//Log System
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in comment fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name . ', Ip: ' . $blog_threat_ip ));
					//Insert in buffer
					$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $blog_threat_ip ));

					$table_prefix = $wpdb->base_prefix;
					$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");

					return wp_die( __( '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master' ) );
				}
			}
		}

		//Contact Form 7
		function spam_master_add_honeypot_to_form( $content ) {
			$content .= '<p class="spam-master-hidden">
						<label class="spam-master-hidden" for="mothers_name">Mother Name<br>
						<input type="text" name="mothers_name" id="mothers_name" class="input" value="" size="25" autocomplete="off" />
						</label>
						</p>
						<p class="spam-master-hidden">
						<label class="spam-master-hidden" for="mothers_last_name">Mother Last Name<br>
						<input type="type="text" name="mothers_last_name" id="mothers_last_name" class="input" value="" size="25" autocomplete="off" />
						</label>
						</p>';
			return $content;        
		}
		function spam_master_contact_form_7_hoenypot($spam){
		global $wpdb, $blog_id;

			if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
				if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
					$mothers_name = 'empty';
				}
				else{
					$mothers_name = $_POST['mothers_name'];
				}
				if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
					$mothers_last_name = 'empty';
				}
				else{
					$mothers_last_name = $_POST['mothers_last_name'];
				}

				//Report only, create data to be posted
				$blog_license_key = get_option('spam_license_key');
				$blog_threat_type = 'honeypot';
				$blog_web_address = get_site_url();
				$address_unclean = $blog_web_address;
				$address = preg_replace('#^https?://#', '', $address_unclean);
				@$blog_server_ip = $_SERVER['SERVER_ADDR'];
				//if empty ip
				if(empty($blog_server_ip) || $blog_server_ip == '0'){
					@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
				}
				//Remote Ip
				$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
				//Add Tables
				$table_threats = $wpdb->prefix."spam_master_threats";
				$table_keys = $wpdb->prefix."spam_master_keys";
				$spam_master_learning_post = array(
													'blog_license_key' => $blog_license_key,
													'blog_threat_ip' => $blog_threat_ip,
													'blog_threat_type' => $blog_threat_type,
													'blog_threat_email' => 'honey@'.date('YmdHis').'.wp',
													'blog_threat_content' => 'Honeypot Contact Form 7 Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
													'blog_web_adress' => $address,
													'blog_server_ip' => $blog_server_ip
											);										
				$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5faG9uZXkucGhw';
				$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																							'method' => 'POST',
																							'timeout' => 45,
																							'body' => $spam_master_learning_post
																					));
				//Log System
				$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Honeypot', 'spamvalue' => 'Blocked in Contact Form 7 fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name . ', Ip: ' . $blog_threat_ip ));
				//Insert in buffer
				$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $blog_threat_ip ));

				$table_prefix = $wpdb->base_prefix;
				$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");

				return  $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
				exit();
			}
		}


	//end honeypot ture
	}
// end valid
}
?>
