<?php
if(is_multisite()){
	$response_key = get_blog_option($blog_id, 'spam_master_status');
	$spam_master_recaptcha_registration = get_blog_option($blog_id, 'spam_master_recaptcha_registration');
	$spam_master_recaptcha_login = get_blog_option($blog_id, 'spam_master_recaptcha_login');
	$spam_master_recaptcha_comments = get_blog_option($blog_id, 'spam_master_recaptcha_comments');
	$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
	$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
	$spam_master_recaptcha_ampoff = get_blog_option($blog_id, 'spam_master_recaptcha_ampoff');
}
else{
	$response_key = get_option('spam_master_status');
	$spam_master_recaptcha_registration = get_option('spam_master_recaptcha_registration');
	$spam_master_recaptcha_login = get_option('spam_master_recaptcha_login');
	$spam_master_recaptcha_comments = get_option('spam_master_recaptcha_comments');
	$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
	$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
	$spam_master_recaptcha_ampoff = get_option('spam_master_recaptcha_ampoff');
}
if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){

	//HOOK AMP FUNCTION
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/protection/spam-master-amp-fun.php');

	//////////////////////////////////////////////
	//IMPLEMENT RECAPTCHA FRONTEND REGISTRATIONS//
	if ($spam_master_recaptcha_registration == 'true'){
		if ($spam_master_recaptcha_public_key !== ''){
			if ( !('true' == spam_master_amp_check() && !( 'true' == $spam_master_recaptcha_ampoff ) ) ) {
				//MULTISITE HOOKS
				if(is_multisite()){
					add_action('signup_extra_fields', 'spam_master_recaptcha_register_field' );
					add_action('register_form', 'spam_master_recaptcha_register_field' );
					add_action('wpmu_validate_user_signup', 'spam_master_recaptcha_register_multi_errors', 99);
				}
				//SINGLE SITE HOOKS
				else{
					add_action('login_enqueue_scripts', 'spam_master_recaptcha_css');
					add_action('register_form', 'spam_master_recaptcha_register_field' );
					add_action( 'registration_errors', 'spam_master_recaptcha_register_single_errors', 10, 3 );
				}
			}
			//CSS FOR SINGLE SITE
			function spam_master_recaptcha_css(){
				wp_register_style( 'spam_master_recaptcha_css', plugins_url('../../css/spam-master-recaptcha.css',  __FILE__) );
				wp_enqueue_style( 'spam_master_recaptcha_css' );
			}
			//END CSS

			//INSERT FIELD
			function spam_master_recaptcha_register_field(){
			global $wpdb, $blog_id;
			if(is_multisite()){
			$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
			$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
			}
			else{
			$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
			$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
			}
				?>
				<label>Re-CAPTCHA Code</label>
				<?php
				echo '<script src="https://www.google.com/recaptcha/api.js" async defer></script>';
				echo '<div class="g-recaptcha" data-theme="' . $spam_master_recaptcha_theme . '" data-sitekey="' . $spam_master_recaptcha_public_key . '"></div>';
				if (is_multisite()){
				?>
				<p>Press <b>Next</b> after verifying captcha.</p>
				<br>
				<?php
				}
				else{
				?>
				<p>Press <b>Register</b> after verifying captcha.</p>
				<br>
				<?php
				}
			}
			//CAPTCH VERIFICATION 
			function captcha_verification() {
			global $wpdb, $blog_id;
			if(is_multisite()){
			$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
			}
			else{
			$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
			}
				$response = isset( $_POST['g-recaptcha-response'] ) ? esc_attr( $_POST['g-recaptcha-response'] ) : '';

				$remote_ip = $_SERVER["REMOTE_ADDR"];

				// make a GET request to the Google reCAPTCHA Server
				$request = wp_remote_get(
					'https://www.google.com/recaptcha/api/siteverify?secret=' . $spam_master_recaptcha_secret_key . '&response=' . $response . '&remoteip=' . $remote_ip
				);

				// get the request response body
				$response_body = wp_remote_retrieve_body( $request );

				$result = json_decode( $response_body, true );

				return $result['success'];
			}
			//START ERRORS VALIDATION MULTI SITE
			function spam_master_recaptcha_register_multi_errors($result){
			global $wpdb, $blog_id;
				if(isset($_POST['g-recaptcha-response'])){
					$captcha=$_POST['g-recaptcha-response'];

					//Remote Ip
					$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
					//Add Tables
					$table_keys = $wpdb->prefix."spam_master_keys";
					//Log System
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Firewall', 'spamvalue' => 'reCaptcha Registration Spam Check Triggered. Incoming: '.$blog_threat_ip ));

					if(!$captcha){
						$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'reCaptcha', 'spamvalue' => 'Wrong reCaptcha in registration, Ip: ' . $blog_threat_ip ));
						$table_prefix = $wpdb->base_prefix;
						$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");

						//Report only, create data to be posted
						$blog_license_key = get_blog_option($blog_id, 'spam_license_key');
						$blog_threat_type = 'captcha';
						$blog_web_address = get_site_url();
						$address_unclean = $blog_web_address;
						$address = preg_replace('#^https?://#', '', $address_unclean);
						@$blog_server_ip = $_SERVER['SERVER_ADDR'];
						//if empty ip
						if(empty($blog_server_ip) || $blog_server_ip == '0'){
							@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
						}
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $blog_threat_ip,
															'blog_threat_type' => $blog_threat_type,
															'blog_threat_email' => 'captcha@'.date('YmdHis').'.wp',
															'blog_threat_content' => 'Page: registration Ip : ' . $blog_threat_ip,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
													);										
						$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5fY2FwdGNoYS5waHA=';
						$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																									'method' => 'POST',
																									'timeout' => 45,
																									'body' => $spam_master_learning_post
																							));
						$result['errors']->add('invalid_email',__('<strong>SPAM MASTER</strong>: Insert Correct Captcha','spam_master'));
						echo '<p class="error"><strong>SPAM MASTER</strong>: Insert Correct Captcha</p>';
					}
				}
			return $result;
			}
			//START ERRORS VALIDATION SINGLE SITE
			function spam_master_recaptcha_register_single_errors($errors, $sanitized_user_login, $user_email){
			global $wpdb, $blog_id;

				//Remote Ip
				$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
				//Add Tables
				$table_keys = $wpdb->prefix."spam_master_keys";
				//Log System
				$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Firewall', 'spamvalue' => 'reCaptcha Registration Spam Check Triggered. Incoming: '.$blog_threat_ip ));

				if ( isset( $_POST['g-recaptcha-response'] ) && !captcha_verification() ) {
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'reCaptcha', 'spamvalue' => 'Wrong reCaptcha in registration, Ip: ' . $blog_threat_ip ));
					$table_prefix = $wpdb->base_prefix;
					$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");
	
					//Report only, create data to be posted
					$blog_license_key = get_option('spam_license_key');
					$blog_threat_type = 'captcha';
					$blog_web_address = get_site_url();
					$address_unclean = $blog_web_address;
					$address = preg_replace('#^https?://#', '', $address_unclean);
					@$blog_server_ip = $_SERVER['SERVER_ADDR'];
					//if empty ip
					if(empty($blog_server_ip) || $blog_server_ip == '0'){
						@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $blog_threat_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => 'captcha@'.date('YmdHis').'.wp',
														'blog_threat_content' => 'Page: registration Ip : ' . $blog_threat_ip,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5fY2FwdGNoYS5waHA=';
					$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																									'method' => 'POST',
																									'timeout' => 45,
																									'body' => $spam_master_learning_post
																							));
					$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Insert Correct Captcha','spam_master') );
					return $errors;
				}
			return $errors;
			//END ERRORS VALIDATION
			}
		//END public key
		}
	//END $spam_master_recaptcha_registration - true
	}

	//////////////////////////////////////
	//IMPLEMENT RECAPTCHA FRONTEND LOGIN//
	if ($spam_master_recaptcha_login == 'true'){
		if ($spam_master_recaptcha_public_key !== ''){
			if ( !('true' == spam_master_amp_check() && !( 'true' == $spam_master_recaptcha_ampoff ) ) ) {
				//MULTISITE HOOKS
				if(is_multisite()){
					add_action('signup_extra_fields', 'spam_master_recaptcha_login_field' );
					add_action('login_form', 'spam_master_recaptcha_login_field');
					add_action('login_head', 'spam_master_recaptcha_login_errors', 99);
				}
				//SINGLE SITE HOOKS
				else{
					add_action('login_enqueue_scripts', 'spam_master_recaptcha_login_css');
					add_action('login_form', 'spam_master_recaptcha_login_field');
					add_filter( 'login_errors', 'spam_master_recaptcha_login_errors', 10, 3 );
				}
			}
			//CSS FOR SINGLE SITE
			function spam_master_recaptcha_login_css(){
				wp_register_style( 'spam_master_recaptcha_login_css', plugins_url('../../css/spam-master-recaptcha.css',  __FILE__) );
				wp_enqueue_style( 'spam_master_recaptcha_login_css' );
			}
			//END CSS
			//INSERT FIELD
			function spam_master_recaptcha_login_field(){
			global $wpdb, $blog_id;
				if(is_multisite()){
					$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
				}
				else{
					$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
				}
					echo	'<script src="https://www.google.com/recaptcha/api.js"></script>';
					echo	'<label>Re-CAPTCHA Code</label>' .
							'<div class="g-recaptcha" data-theme="'.$spam_master_recaptcha_theme.'" data-sitekey="' . $spam_master_recaptcha_public_key . '"></div>';
				//END FIELD
				}
				//START ERRORS VALIDATION
				function spam_master_recaptcha_login_errors($error) {
				global $wpdb, $blog_id, $errors;
				$err_codes = $errors->get_error_codes();
				if(is_multisite()){
					$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
					$blog_license_key = get_blog_option($blog_id, 'spam_license_key');
				}
				else{
					$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
					$blog_license_key = get_option('spam_license_key');
				}
				if ( isset( $_POST['g-recaptcha-response'] ) ) {
					$response = wp_remote_get( 'https://www.google.com/recaptcha/api/siteverify?secret=' . $spam_master_recaptcha_secret_key . '&response=' . $_POST['g-recaptcha-response'] );
					$response = json_decode( $response['body'], true );
					
					//Remote Ip
					$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
					//Add Tables
					$table_keys = $wpdb->prefix."spam_master_keys";
					//Log System
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Firewall', 'spamvalue' => 'reCaptcha login Spam Check Triggered. Incoming: '.$blog_threat_ip ));
					
					if ( false === $response['success'] ) {
						$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'reCaptcha', 'spamvalue' => 'Wrong reCaptcha in login, Ip: ' . $blog_threat_ip ));
						$table_prefix = $wpdb->base_prefix;
						$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");

						//Report only, create data to be posted
						$blog_threat_type = 'captcha';
						$blog_web_address = get_site_url();
						$address_unclean = $blog_web_address;
						$address = preg_replace('#^https?://#', '', $address_unclean);
						@$blog_server_ip = $_SERVER['SERVER_ADDR'];
						//if empty ip
						if(empty($blog_server_ip) || $blog_server_ip == '0'){
							@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
						}
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $blog_threat_ip,
															'blog_threat_type' => $blog_threat_type,
															'blog_threat_email' => 'captcha@'.date('YmdHis').'.wp',
															'blog_threat_content' => 'Page: login Ip : ' . $blog_threat_ip,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
													);										
						$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5fY2FwdGNoYS5waHA=';
						$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																									'method' => 'POST',
																									'timeout' => 45,
																									'body' => $spam_master_learning_post
																							));
						$error = '<strong>SPAM MASTER:</strong> Insert Correct Captcha';
						
					}
				}
			return $error;
			}
		//END public key
		}
	//END $spam_master_recaptcha_login - true
	}

	/////////////////////////////////////////
	//IMPLEMENT RECAPTCHA FRONTEND COMMENTS//
	if ($spam_master_recaptcha_comments == 'true'){
		if ($spam_master_recaptcha_public_key !== ''){
			if ( !('true' == spam_master_amp_check() && !( 'true' == $spam_master_recaptcha_ampoff ) ) ) {
				//MULTISITE HOOKS
				if(is_multisite()){
					add_action( 'comment_form_after_fields', 'spam_master_comment_field', 1);
					add_filter( 'preprocess_comment', 'spam_master_verify_comment_data' );
				}
				//SINGLE SITE HOOKS
				else{
					add_action('wp_enqueue_scripts', 'spam_master_recaptcha_comments_css');
					add_action( 'comment_form_after_fields', 'spam_master_comment_field', 1);
					add_filter( 'preprocess_comment', 'spam_master_verify_comment_data' );
				}
			}

			//CSS FOR SINGLE SITE
			function spam_master_recaptcha_comments_css(){
				wp_register_style( 'spam_master_recaptcha_comments_css', plugins_url('../../css/spam-master-recaptcha.css',  __FILE__) );
				wp_enqueue_style( 'spam_master_recaptcha_comments_css' );
			}
			//END CSS
			function spam_master_comment_field(){
			global $wpdb, $blog_id;
				if(is_multisite()){
					$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
				}
				else{
					$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
				}
				echo	'<script src="https://www.google.com/recaptcha/api.js"></script>';
				echo	'<p class="comment-form-recaptcha">' .
						'<label>Re-CAPTCHA Code</label>' .
						'<div class="g-recaptcha" data-theme="'.$spam_master_recaptcha_theme.'" data-sitekey="' . $spam_master_recaptcha_public_key . '"></div></p>';
			}
			//COMMENT VERIFICATION
			function spam_master_verify_comment_data($commentdata){
			global $wpdb, $blog_id;
				if(is_multisite()){
					$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
					$blog_license_key = get_blog_option($blog_id, 'spam_license_key');
				}
				else{
					$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
					$blog_license_key = get_option('spam_license_key');
				}
				if ( isset( $_POST['g-recaptcha-response'] ) ) {
					$response = wp_remote_get( 'https://www.google.com/recaptcha/api/siteverify?secret=' . $spam_master_recaptcha_secret_key . '&response=' . $_POST['g-recaptcha-response'] );
					$response = json_decode( $response['body'], true );

					//Remote Ip
					$blog_threat_ip = $_SERVER['REMOTE_ADDR'];
					//Add Tables
					$table_keys = $wpdb->prefix."spam_master_keys";
					//Log System
					$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'Firewall', 'spamvalue' => 'reCaptcha comment Spam Check Triggered. Incoming: '.$blog_threat_ip ));

					if ( true === $response['success'] ) {
						return $commentdata;
					}
					else {
						$wpdb->insert( $table_keys, array( 'time' => current_time( 'mysql' ), 'spamkey' => 'reCaptcha', 'spamvalue' => 'Wrong reCaptcha in comment, Ip: ' . $blog_threat_ip ));
						$table_prefix = $wpdb->base_prefix;
						$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");

						//Report only, create data to be posted
						$blog_threat_type = 'captcha';
						$blog_web_address = get_site_url();
						$address_unclean = $blog_web_address;
						$address = preg_replace('#^https?://#', '', $address_unclean);
						@$blog_server_ip = $_SERVER['SERVER_ADDR'];
						//if empty ip
						if(empty($blog_server_ip) || $blog_server_ip == '0'){
							@$blog_server_ip = 'I '.gethostbyname($_SERVER['SERVER_NAME']);
						}
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $blog_threat_ip,
															'blog_threat_type' => $blog_threat_type,
															'blog_threat_email' => 'captcha@'.date('YmdHis').'.wp',
															'blog_threat_content' => 'Page: comment Ip : ' . $blog_threat_ip,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
													);										
						$spam_master_leaning_url = 'aHR0cHM6Ly9zcGFtbWFzdGVyLnRlY2hnYXNwLmNvbS93cC1jb250ZW50L3BsdWdpbnMvc3BhbS1tYXN0ZXItYWRtaW5pc3RyYXRvci9pbmNsdWRlcy9sZWFybmluZy9nZXRfbGVhcm5fY2FwdGNoYS5waHA=';
						$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																									'method' => 'POST',
																									'timeout' => 45,
																									'body' => $spam_master_learning_post
																							));
						return wp_die( __( '<strong>SPAM MASTER</strong>: Insert Correct Captcha' ) );
					}
				}
			}
		//END public key
		}
	//END $spam_master_recaptcha_comments - true	
	}

// end valid
}
?>
